const {
    TYPE_PROPERTY,
    TYPE_EVENT,
    TYPE_SERVICE
} = require('./const');


function parse(str) {
    const data = JSON.parse(str);
    const result = {};
    const type = data.type;
    switch(type) {
        case TYPE_PROPERTY:
        case TYPE_EVENT:
        case TYPE_SERVICE:
            assertNotNull('productKey', data.productKey);
            assertNotNull('deviceName', data.deviceName);
            assertNotNull('params', data.params);
            assertNotNull('identifier', data.identifier);
            result.type = type;
            result.productKey = data.productKey;
            result.deviceName = data.deviceName;
            result.identifier = data.identifier;
            try {
                result.params = JSON.parse(data.params);
            } catch (e) {
                throw new Error(`Cannot parse params to json. ${e}`);
            }
            break;
        default:
            throw new Error(`Not support type: ${type}`);
    }
    return result;
}

function assertNotNull(name, value) {
    if (!value) {
        throw new Error(`params[${name}] cannot be null`);
    }
}

module.exports = { parse };